<?php

	// Dismiss Session
	PHPVC_SESSION::VAR_STOP();
	
	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();

	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	

	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_CAT_COMPANY_ID',
					'PARAM_CAT_COMPANY_DESCRIPTION',
					'PARAM_CAT_COMPANY_TIN',
					'PARAM_CAT_COMPANY_ADDRESS',
					'PARAM_CAT_COMPANY_MOBILE',
					'PARAM_CAT_COMPANY_PHONE',
					'PARAM_CAT_COMPANY_FAX',
					'PARAM_CAT_COMPANY_EMAIL',
					'PARAM_CAT_COMPANY_WEBSITE',
					'PARAM_CAT_COMPANY_SNS_PAGE',
					'PARAM_CAT_COMPANY_COMPANY_TYPE',
					'PARAM_CAT_COMPANY_REMARKS',
					'PARAM_CAT_COMPANY_STATUS',
					'PARAM_CAT_COMPANY_SYSTEM_GENERATED',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_CAT_COMPANY_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_COMPANY_ID');
			$PARAM_CAT_COMPANY_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_DESCRIPTION');
			$PARAM_CAT_COMPANY_TIN = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_TIN');
			$PARAM_CAT_COMPANY_ADDRESS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_ADDRESS');
			$PARAM_CAT_COMPANY_MOBILE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_MOBILE');
			$PARAM_CAT_COMPANY_PHONE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_PHONE');
			$PARAM_CAT_COMPANY_FAX = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_FAX');
			$PARAM_CAT_COMPANY_EMAIL = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_EMAIL');
			$PARAM_CAT_COMPANY_WEBSITE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_WEBSITE');
			$PARAM_CAT_COMPANY_SNS_PAGE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_SNS_PAGE');
			$PARAM_CAT_COMPANY_COMPANY_TYPE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_COMPANY_TYPE');
			$PARAM_CAT_COMPANY_REMARKS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_REMARKS');
			$PARAM_CAT_COMPANY_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_CAT_COMPANY_STATUS');
			$PARAM_CAT_COMPANY_SYSTEM_GENERATED = PHPCUS_PARAM::CUS_READ_INT('PARAM_CAT_COMPANY_SYSTEM_GENERATED');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'CAT_COMPANY_ID', 
						'CAT_COMPANY_DESCRIPTION', 
						'CAT_COMPANY_TIN', 
						'CAT_COMPANY_ADDRESS', 
						'CAT_COMPANY_MOBILE', 
						'CAT_COMPANY_PHONE', 
						'CAT_COMPANY_FAX', 
						'CAT_COMPANY_EMAIL', 
						'CAT_COMPANY_WEBSITE', 
						'CAT_COMPANY_SNS_PAGE', 
						'CAT_COMPANY_COMPANY_TYPE', 
						'CAT_COMPANY_REMARKS', 
						'CAT_COMPANY_STATUS', 
						'CAT_COMPANY_SYSTEM_GENERATED'
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_CATEGORY_COMPANY::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_ID'] = $PARAM_CAT_COMPANY_ID;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_DESCRIPTION'] = $PARAM_CAT_COMPANY_DESCRIPTION;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_TIN'] = $PARAM_CAT_COMPANY_TIN;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_ADDRESS'] = $PARAM_CAT_COMPANY_ADDRESS;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_MOBILE'] = $PARAM_CAT_COMPANY_MOBILE;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_PHONE'] = $PARAM_CAT_COMPANY_PHONE;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_FAX'] = $PARAM_CAT_COMPANY_FAX;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_EMAIL'] = $PARAM_CAT_COMPANY_EMAIL;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_WEBSITE'] = $PARAM_CAT_COMPANY_WEBSITE;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_SNS_PAGE'] = $PARAM_CAT_COMPANY_SNS_PAGE;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_COMPANY_TYPE'] = $PARAM_CAT_COMPANY_COMPANY_TYPE;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_REMARKS'] = $PARAM_CAT_COMPANY_REMARKS;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_STATUS'] = $PARAM_CAT_COMPANY_STATUS;
			$GET_MAP_ARRAY['PARAM_CAT_COMPANY_SYSTEM_GENERATED'] = $PARAM_CAT_COMPANY_SYSTEM_GENERATED;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_CATEGORY_COMPANY::CUS_GET_SUM_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>